IDSTR_CLIENT_INSPECTOR           = 00131500, "Game Inspector";

newActionMap( "SimGame.sae" );
bindCommand(keyboard0, make, alt, g, TO, "ShowGameInspector();");

function MissionObjectList::onSelectionCleared()
{
   //MissionObjectList::Inspect(1, -1);
   //$CI::InspectObject = "";
}


function MissionObjectList::onSelected(%world, %obj)
{
	$CI::InspectObject = %obj;
	$CI::InspectWorld = %world;
	MissionObjectList::Inspect($CI::InspectWorld, %obj);
}

function ApplyButton::onAction()
{
MissionObjectList::Apply();
}

function Cut::onAction()
{
	if(isobject($CI::InspectObject))
	{
	StoreObject($CI::InspectObject, TempClientInspectorObject);
	DeleteObject($CI::InspectObject);
	Control::SetVisible(Paste, true);
	Control::SetVisible(Cut, false);
	$CI::InspectObject = 0;
	}
}

function Paste::onAction()
{
	LoadObject("PastedObject", TempClientInspectorObject);
	%TempObject = GetObjectID(PastedObject);
	RenameObject(PastedObject, PastedObject @ RandomInt(1, 9999));
	AddtoSet($CI::InspectObject, %TempObject);
	Control::SetVisible(Paste, false);
	Control::SetVisible(Cut, true);
	MissionObjectList::Inspect(2, %TempObject);
}

function Copy::onAction()
{
	if(isobject($CI::InspectObject))
	{
	StoreObject(TempClientInspectorObject, $CI::InspectObject);
	Control::SetVisible(Paste, true);
	Control::SetVisible(Cut, false);
	}
}

function Delete::onAction()
{
	if(isobject($CI::InspectObject))
	{
	DeleteObject($CI::InspectObject);
	$CI::InspectObject = 0;
	MissionObjectList::Inspect(2, -1);
	}
}

function StoreVehicle::onAction()
{
	if(getVehicleAvailableMass($CI::InspectObject)!=False)
	{
	Control::SetVisible(StoreVehicleWindow, true);
	$TempVehicleStore = $CI::InspectObject;
	}
}

function StoreVehicleConfirm::onAction()
{
	if(($VehicleFileName=="") || ($VehicleFileName=="File name required"))
	{
	Control::SetText(VehicleTextEdit, "File name required");
	}
	else
	{
	StoreObject($TempVehicleStore, "vehicles\\" @ $VehicleFileName @ ".veh");
	DoVehicleStoreStatus();
	}
}

function DoVehicleStoreStatus()
{
Control::SetActive(StoreVehicleConfirm, false);
Control::SetText(VehicleTextEdit, "Storing.");
Schedule("Control::SetText(VehicleTextEdit, 'Storing..');", "0.1");
Schedule("Control::SetText(VehicleTextEdit, 'Storing...');", "0.2");
Schedule("Control::SetText(VehicleTextEdit, 'Storing....');", "0.3");
Schedule("Control::SetText(VehicleTextEdit, 'Storing.....');", "0.4");
Schedule("Control::SetText(VehicleTextEdit, 'Storing.');", "0.5");
Schedule("Control::SetText(VehicleTextEdit, 'Storing..');", "0.6");
Schedule("Control::SetText(VehicleTextEdit, 'Storing...');", "0.7");
Schedule("Control::SetText(VehicleTextEdit, 'Storing....');", "0.8");
Schedule("Control::SetText(VehicleTextEdit, 'Storing.....');", "0.9");
Schedule("Control::SetText(VehicleTextEdit, '');$VehicleFileName='';", "0.95");
Schedule("Control::SetActive(StoreVehicleConfirm, true);Control::SetVisible(StoreVehicleWindow, false);", "1");
}

function ServerTreeButton::onAction()
{
	focusserver();
	if(isobject(MissionGroup))
	{
		if(!$TreeToggle)
		{
		$TreeToggle=1;
		Control::SetText(ServerTreeButton, "Client Tree");
		MissionObjectList::ClearDisplayGroups();
		MissionObjectList::AddDisplayGroup(1, 0);
		MissionObjectList::SetSelMode(1);
		MissionObjectList::Inspect(2, -1);
		}
		else
		{
		$TreeToggle=0;
		Control::SetText(ServerTreeButton, "Server Tree");
		MissionObjectList::ClearDisplayGroups();
		MissionObjectList::AddDisplayGroup(2, 0);
   		MissionObjectList::SetSelMode(2);
		MissionObjectList::Inspect(2, -1);
		}
	}
	focusclient();
}

function ShowGameInspector()
{
	ClientCursorOn();
	GuiPushDialog(simcanvas,"GameInspector.dlg");
	Control::SetText(ServerTreeButton, "Server Tree");
	MissionObjectList::ClearDisplayGroups();
	MissionObjectList::AddDisplayGroup(2, 0);
}